package com.jz.common.utils;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

import com.jz.dmp.modules.controller.bean.DmpNavigationTreeDto;

/**
 * @ClassName: ReflectAssistUtils
 * @Description: TODO(反射辅助工具类)
 * @author ybz
 * @date 2021年1月26日
 *
 */
public class ReflectAssistUtils {
	
	/**  
	* @Title: getFieldValueByFieldName  
	* @Description: TODO(根据属性名称获取属性值)  
	* @param @param fieldName
	* @param @param cls
	* @param @return
	* @param @throws Exception    参数  
	* @return Field    返回类型  
	* @throws  
	*/ 
	public static Object getFieldValueByFieldName(String fieldName, Object obj)throws Exception{
		Class<?> cls = obj.getClass();
		String getMethodName = "get"+fieldName.substring(0, 1).toUpperCase()+fieldName.substring(1);
		Method getMethod = cls.getMethod(getMethodName);
		return getMethod.invoke(obj);
	}
	
	/**
	 * @param <T>  
	* @Title: setFieldValueByFieldName  
	* @Description: TODO(设置属性值)  
	* @param @param fieldName
	* @param @param cls
	* @param @param fieldVaule
	* @param @throws Exception    参数  
	* @return void    返回类型  
	* @throws  
	*/ 
	public static <T> void setFieldValueByFieldName(String fieldName, Object obj, T fieldVaule)throws Exception{
		Class<?> cls = obj.getClass();
		String setMethodName = "set"+fieldName.substring(0, 1).toUpperCase()+fieldName.substring(1);
		Class<?> fieldValueClass = fieldVaule.getClass();
		if (fieldVaule instanceof ArrayList) {
			fieldValueClass = List.class;
		}
		Method setMethod = cls.getMethod(setMethodName, fieldValueClass);
		setMethod.invoke(obj, fieldVaule);
	}
	
	public static void main(String[] args) {
		try {
			DmpNavigationTreeDto dmpNavigationTreeDto = new DmpNavigationTreeDto();
			List<DmpNavigationTreeDto> list = new ArrayList<DmpNavigationTreeDto>();
			setFieldValueByFieldName("children", dmpNavigationTreeDto, list);
			System.out.println(getFieldValueByFieldName("children", dmpNavigationTreeDto));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
