package com.jz.dmp.modules.service.sys;

import javax.servlet.http.HttpServletRequest;

import com.jz.common.bean.BaseBeanResponse;
import com.jz.common.bean.BaseResponse;
import com.jz.common.bean.PageInfoResponse;
import com.jz.dmp.modules.controller.sys.bean.DmpRolePermissionBatch;
import com.jz.dmp.modules.controller.sys.bean.DmpRolePermissionDto;
import com.jz.dmp.modules.controller.sys.bean.DmpRolePermissionRequest;
import com.jz.dmp.modules.model.DmpRolePermission;

/**
 * 角色资源关系表服务接口
 * @author ybz
 *
 */
public interface DmpRolePermissionService {

	/**条件查询所有角色资源关系表
	 * @param dmpRolePermissionRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public PageInfoResponse<DmpRolePermissionDto> findList(DmpRolePermissionRequest dmpRolePermissionRequest, HttpServletRequest httpRequest)throws Exception;
	

	/**新增角色资源关系表
	 * @param dmpRolePermission
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpRolePermission> add(DmpRolePermission dmpRolePermission, HttpServletRequest httpRequest)throws Exception;
	
	/**主键查询角色资源关系表
	 * @param dmpRolePermissionRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpRolePermissionDto> findById(DmpRolePermissionRequest dmpRolePermissionRequest, HttpServletRequest httpRequest)throws Exception;

	/**修改角色资源关系表
	 * @param dmpRolePermission
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpRolePermission> edit(DmpRolePermission dmpRolePermission, HttpServletRequest httpRequest)throws Exception;

	/**主键删除角色资源关系表
	 * @param dmpRolePermissionRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse deleteById(DmpRolePermissionRequest dmpRolePermissionRequest, HttpServletRequest httpRequest)throws Exception;

	/**批量新增角色资源关系表
	 * @param dmpRolePermissionVo
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpRolePermissionBatch> addBatch(DmpRolePermissionBatch dmpRolePermissionBatch, HttpServletRequest httpRequest)throws Exception;

}
